// Get the value of the use_javascript from drupalSettings
var use_javascript = drupalSettings.openai_search.use_javascript;
var node_type = drupalSettings.openai_search.node_type;
var ai_url = drupalSettings.openai_search.ai_url;

function waitForElm(selector) {
  return new Promise(resolve => {
    if (document.querySelector(selector)) {
      return resolve(document.querySelector(selector));
    }

    const observer = new MutationObserver(mutations => {
      if (document.querySelector(selector)) {
        resolve(document.querySelector(selector));
        observer.disconnect();
      }
    });

    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
  });
}

waitForElm('#js-submit').then((elm) => {
  document.getElementById('js-submit').addEventListener('click', function(e) {
    // Prevent the default form submission
    if (use_javascript === 1) {
      e.preventDefault();
    }
    else {
      return;
    }
    // change the id of spinner to be visible
    document.getElementById('wtk-ai-spinner').style.display = 'block';
    // Get the search query
    var searchQuery = document.getElementById('user-search-id').value;
    // make searchQuery url friendly
    searchQuery = searchQuery.replace(/ /g, '+');
    if (node_type == "private_gpts") {
      var session_id = drupalSettings.openai_search.session_id;
      console.log("session_id is " + session_id);
      var url = ai_url + "/" + searchQuery + '?UNIQUE_SESSION_COOKIE_NAME=' + drupalSettings.openai_search.session_id;
    }
    console.log("url is " + url);
    // Get the response from the server
    fetch(url, {
      method: 'GET',
      headers: {
        'Accept': 'application/json',
      },
    })
      .then(response => response.json())
      .then(data => {
        // Only show the response, not the full object
        var output = (data && typeof data === 'object' && 'response' in data) ? data.response : 'No response received';
        document.getElementById('output').textContent = output;
        document.getElementById('wtk-ai-spinner').style.display = 'none';
      })
      .catch(error => {
        document.getElementById('output').textContent = 'Error: ' + error;
        document.getElementById('wtk-ai-spinner').style.display = 'none';
      });
  });
});
