<?php
namespace Drupal\openai_search\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Core\Block\BlockPluginInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Provides a block for the React Private GPT Node Creator.
 *
 * @Block(
 *   id = "openai_search_node_creator_block",
 *   admin_label = @Translation("Private GPT Node Creator (React)"),
 *   category = @Translation("OpenAI Search")
 * )
 */
class NodeCreatorBlock extends BlockBase implements BlockPluginInterface, ContainerFactoryPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function build() {
    // Attach the React app's JS and pass user roles to drupalSettings.
    $current_user = \Drupal::currentUser();
    $roles = $current_user->getRoles();
    $build = [];
    $build['#attached']['library'][] = 'openai_search/node_creator_block';
    $build['#attached']['drupalSettings']['user']['roles'] = $roles;
    $build['#markup'] = '<div id="node-creator-root"></div>';
    return $build;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static($configuration, $plugin_id, $plugin_definition);
  }
}
